.CODE

;-- CreateFontBold: create bold font from main dialog font
;                   call DeleteObject in WM_CLOSE
CreateFontBold PROC hWndParent:DWORD,idCtrl:DWORD

Local logF:LOGFONT
Local hControl:HANDLE
Local hdc:HANDLE

;-- retrieve handle of control
	Invoke GetDlgItem,hWndParent,idCtrl
	mov hControl,eax
;-- retrieve the handle of the font used by the control
	Invoke SendMessage,hControl,WM_GETFONT,0,0
	mov edx,eax
;-- retrieve information about the font object
	Invoke GetObject,edx,SIZEOF logF,ADDR logF
;-- Set font weight property to bold
	mov logF.lfWeight,FW_SEMIBOLD			
;-- Create new (bold) font object
	invoke CreateFontIndirect,ADDR logF
;-- Returns handle to new font in eax, NULL for error
	ret
CreateFontBold EndP

;-- SetCmdIcon: Set button icon
SetCmdIcon PROC hWnd:DWORD,idDlgItem:DWORD,idIcon:DWORD

	Invoke LoadImage,hInstance,idIcon,IMAGE_ICON,0,0,LR_DEFAULTCOLOR
	push eax
	Invoke SendDlgItemMessage,hWnd,idDlgItem,BM_SETIMAGE,IMAGE_ICON,eax
	pop eax
	Invoke DeleteObject,eax
	xor eax,eax
	ret
SetCmdIcon EndP


;-- SaveDialogProc: initialize and create a Save common dialog box
SaveDialogProc proc hwnd:HWND

Local os:OSVERSIONINFO
LOCAL OFN:OPENFILENAME_NT
Local szBuffer[64]:BYTE 
Local numBytes:DWORD
Local hDHFile:DWORD

;-- Determine OS version
	mov	os.dwOSVersionInfoSize,SIZEOF(OSVERSIONINFO)
	Invoke GetVersionEx,ADDR os
;-- Use structure with size related to OS version
;-- tested with Win98SE, W2K SP4 and WindowsXP 64bit beta - ok
	.if os.dwMajorVersion >= 5                            ; W2K and above
		mov OFN.lStructSize,SIZEOF (OPENFILENAME_NT)      ; EQU 88 bytes
	.elseif
		mov OFN.lStructSize,OPENFILENAME_SIZE_VERSION_400 ; EQU 76 bytes
	.endif
	
	push hwnd
	pop OFN.hwndOwner
	push hInstance
	pop OFN.hInstance
	mov OFN.lpstrFilter,offset szFilter	; Pointer to a buffer containing pairs of null-terminated filter strings.
	mov OFN.lpstrCustomFilter,NULL
;	mov OFN.nFilterIndex,0				; Specifies the index of the currently selected filter in the File Types control.
	mov edx,pSTcpy
	lea edx,(STA PTR [edx]).szFileName	
	mov OFN.lpstrFile,edx				; Pointer to a buffer that contains a file name used to initialize the File Name edit control.
	mov OFN.nMaxFile,MAX_PATH			; Specifies the size, in TCHARs, of the buffer pointed to by lpstrFile.
	lea edx,szFileTitle
	mov OFN.lpstrFileTitle,edx			; Pointer to a buffer that receives the file name and extension without path information.
	mov OFN.nMaxFileTitle,MAX_PATH		; Specifies the size, in TCHARs, of the buffer pointed to by lpstrFileTitle
	lea edx,szDefExt
	mov OFN.lpstrDefExt,edx				; Pointer to a buffer that contains the default extension.
	
	mov OFN.lpstrInitialDir,NULL		; Pointer to a NULL terminated string that can specify the initial directory.
	mov OFN.lpstrTitle,offset szCaption ; Pointer to a string to be placed in the title bar of the dialog box.
	
	mov OFN.Flags,OFN_PATHMUSTEXIST or\
                  OFN_EXPLORER or OFN_CREATEPROMPT or OFN_OVERWRITEPROMPT

	invoke GetSaveFileName,addr OFN

	.If eax == TRUE	; ok, valid input
	;-- create empty file
		mov edx,pSTcpy
		lea edx,(STA PTR [edx]).szFileName
		Invoke CreateFile,edx,GENERIC_ALL,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
		mov hDHFile,eax
	;-- write time stamp
		Invoke WriteFile,hDHFile,SADD("LogFile created: "),17,ADDR numBytes,0
		;-- clear string
		xor eax,eax
		lea edx,szBuffer				
		mov [edx],eax
	;-- write current date and time
		invoke DateTime2sz,ADDR szBuffer
		Invoke StrLen,ADDR szBuffer
		mov edx,eax
		Invoke WriteFile,hDHFile,ADDR szBuffer,edx,ADDR numBytes,0
		;-- add crlf
		Invoke WriteFile,hDHFile,SADD(13,10,13,10),4,ADDR numBytes,0
		;-- ready for now
		Invoke CloseHandle,hDHFile
		;-- show selected text in textbox
		mov edx,pSTcpy
		lea edx,(STA PTR [edx]).szFileName
		Invoke SendDlgItemMessage,hwnd,IDC_PATH,WM_SETTEXT,0,edx
	.else         ; cancel owe
	;-- empty szFileName / disable file writing
		mov edx,pSTcpy
		lea edx,(STA PTR [edx]).szFileName
		xor ecx,ecx
		mov [edx],ecx
		Invoke SendDlgItemMessage,hwnd,IDC_PATH,WM_SETTEXT,0,ADDR szEmpty
		mov edx,pSTcpy
		mov (STA PTR [edx]).dwCBState,BST_UNCHECKED
		Invoke ControlED,hwnd
	.endif

	ret

SaveDialogProc endp