.CODE

;-- SetCBFlags: set CheckBoxes to show current flag state and
;               prepare text for logfile output

SetCBFlags PROC USES EBX EDI ESI dwFlags:DWORD

	mov edx,pST
	mov di,(STA PTR [edx]).wFormatF  ; format bytes
	lea ebx,szFlagBuf
	add ebx,2
	lea esi,bF
	mov ecx,1011
@@:
	xor edx,edx
	xor eax,eax
	mov al,[esi]
	bt dwFlags,eax
	setb dl
	push edx
	push ecx
	Invoke SendDlgItemMessage,hCtrl,ecx,BM_SETCHECK,edx,0
	pop ecx
	pop edx
	add dl,30h
	mov [ebx],dl
	add ecx,1
	mov [ebx+1],di
	add esi,1
	add ebx,5
	cmp ecx,1019
	je _exit
	jmp @B
_exit:
	xor eax,eax
	Ret
SetCBFlags EndP

;-- ShowRegisters: show current register contens and
;               prepare text for logfile output

ShowRegisters PROC USES EBX ESI EDI ptrESI:DWORD

	lea esi,szRegBuf			; pointer to buffer
	add esi,5					; first byte to write to
	mov edx,pST
	mov di,(STA PTR [edx]).wFormatR  ; format bytes
	mov ebx,ptrESI				; use (preserved) reg to get register values
	add ebx,4					; flags are located in [esp], regs begin [esp+4]
	mov edx,[ebx+28]			; read EAX value
	invoke dw2hex,edx,esi		; convert to hex
	invoke SendDlgItemMessage,hCtrl,ST_EAX,WM_SETTEXT,0,esi
	mov WORD PTR [esi+8],di	    ; new row
	add esi,15					; next byte to write to
	mov edx,[ebx+24]			; read ECX value
	invoke dw2hex,edx,esi		; ....
	invoke SendDlgItemMessage,hCtrl,ST_ECX,WM_SETTEXT,0,esi
	mov WORD PTR [esi+8],di
	add esi,15
	mov edx,[ebx+20]
	invoke dw2hex,edx,esi
	invoke SendDlgItemMessage,hCtrl,ST_EDX,WM_SETTEXT,0,esi
	mov WORD PTR [esi+8],di
	add esi,15
	mov edx,[ebx+16]
	invoke dw2hex,edx,esi
	invoke SendDlgItemMessage,hCtrl,ST_EBX,WM_SETTEXT,0,esi
	mov WORD PTR [esi+8],di
	add esi,15
	mov edx,[ebx+12]
	invoke dw2hex,edx,esi
	invoke SendDlgItemMessage,hCtrl,ST_ESP,WM_SETTEXT,0,esi
	mov WORD PTR [esi+8],di
	add esi,15
	mov edx,[ebx+8]
	invoke dw2hex,edx,esi
	invoke SendDlgItemMessage,hCtrl,ST_EBP,WM_SETTEXT,0,esi
	mov WORD PTR [esi+8],di
	add esi,15
	mov edx,[ebx+4]
	invoke dw2hex,edx,esi
	invoke SendDlgItemMessage,hCtrl,ST_ESI,WM_SETTEXT,0,esi
	mov WORD PTR [esi+8],di
	add esi,15
	mov edx,[ebx]
	invoke dw2hex,edx,esi
	invoke SendDlgItemMessage,hCtrl,ST_EDI,WM_SETTEXT,0,esi
	mov WORD PTR [esi+8],di
	
	Ret
	
ShowRegisters EndP

ShowStep PROC lpsz:DWORD

	invoke SendDlgItemMessage,hCtrl,ST_STEP_TEXT,WM_SETTEXT,0,lpsz
	
	Ret
ShowStep EndP


;-- WriteLogFile: write current register and flag contens to logfile
WriteLogFile PROC lpszDesc:DWORD

Local lobs:OFSTRUCT
Local hFile:DWORD
Local numBytes:DWORD
Local dwDist:DWORD
Local szLF:WORD
;Local pTempBuf:DWORD
;Local pRsltBuf:DWORD

	
	mov szLF,0A0Dh
;-- check for valid filename
	mov eax,pST
	lea edx,(STA PTR [eax]).szFileName
	xor ecx,ecx
	add cl,[edx]
	jz _exit
	
	mov edx,pST
	push ebx
	lea ebx,(STA PTR [edx]).szFileName
	Invoke OpenFile,ebx,ADDR lobs,OF_EXIST
	.If eax == -1        ; File does NOT exist (HFILE_ERROR == -1)
		Invoke OpenFile,ebx,ADDR lobs,OF_CREATE or OF_WRITE
		mov hFile,eax
	.Else                ; File exists 
		Invoke OpenFile,ebx,ADDR lobs,OF_WRITE
		mov hFile,eax
	.Endif
	pop ebx
	Invoke GetFileSize,hFile,0
	mov dwDist,eax
	Invoke SetFilePointer,hFile,dwDist,0,FILE_BEGIN

;-- Build String
	Invoke StrLen,lpszDesc
	mov edx,eax
	Invoke WriteFile,hFile,lpszDesc,edx,ADDR numBytes,0
	Invoke WriteFile,hFile,ADDR szLF,2,ADDR numBytes,0	
	
	Invoke StrLen,ADDR szRegBuf
	mov edx,eax
	Invoke WriteFile,hFile,ADDR szRegBuf,edx,ADDR numBytes,0
	
	Invoke StrLen,ADDR szFlagBuf
	mov edx,eax
	Invoke WriteFile,hFile,ADDR szFlagBuf,edx,ADDR numBytes,0
		
	Invoke _lclose,hFile
_exit:
	
	Ret
WriteLogFile EndP

;-- DateTime2sz: create date and time string and append it to string at lpszDest
DateTime2sz Proc lpszDest:DWORD

Local pRsltBuf:DWORD

;-- allocate memory for string buffer
	Invoke LocalAlloc,LPTR,128

	mov pRsltBuf,eax
	Invoke GetDateFormat,LOCALE_USER_DEFAULT,DATE_LONGDATE,0,0,eax,64
	Invoke StrLen,pRsltBuf
	mov edx,pRsltBuf
	add edx,eax
	mov WORD PTR [edx],2020h
	add edx,2
	invoke GetTimeFormat,LOCALE_USER_DEFAULT,LOCALE_NOUSEROVERRIDE,0,0,edx,64
	invoke lstrcat,lpszDest,pRsltBuf
	
	Invoke LocalFree,pRsltBuf
	xor eax,eax
	Ret
	
DateTime2sz EndP