SetCBFlags     PROTO :DWORD
ShowRegisters  PROTO :DWORD
ShowStep       PROTO :DWORD
DateTime2sz    PROTO :DWORD
WriteLogFile   PROTO :DWORD

; Macro: show register and flags in the dialog box.
; Usage: RegFlag lpszDescr (OPTIONAL: dwSleep==0)
; IN:    lpszDescr: Required
;					Pointer to string (i. e. source) shown in textbox
;        dwSleep:   Optional (default = 0)
;					delay before next line is shown
;					passing a value != 0 in macro call overrides STA.dwSleep
; OUT:   no return code, every register and flag contains
;        same information as before.

RegFlag MACRO lpszDescr:REQ,dwMSleep:=<0>

; Show flags and registers
	pushad		; push registers
	pushfd		; push all flags

	Invoke SetCBFlags,[esp]				; Show flags setting in dialog
	Invoke ShowRegisters,esp			; Show registers setting in dialog
	Invoke ShowStep,lpszDescr			; Show source code
	mov edx,pST
	mov eax,(STA PTR [edx]).dwCBState
	.if eax == BST_CHECKED
		Invoke WriteLogFile,lpszDescr	; write log file if required
	.endif
	
	mov edx,dwMSleep
	.If edx != 0
		Invoke Sleep,dwMSleep			; custom code delay
	.Else
		mov eax,pST
		mov edx,(STA PTR [eax]).dwSleep
		Invoke Sleep,edx				; options code delay
	.Endif
	
	popfd		; restore flags
	popad		; restore registes

EndM

.DATA

bF			BYTE 0,2,4,6,7,8,0Ah,0Bh

szRegBuf    BYTE "EAX: ", 10 DUP (0),\
                 "ECX: ", 10 DUP (0),\
                 "EDX: ", 10 DUP (0),\
                 "EBX: ", 10 DUP (0),\
                 "ESP: ", 10 DUP (0),\
                 "EBP: ", 10 DUP (0),\
                 "ESI: ", 10 DUP (0),\
                 "EDI: ", 10 DUP (0),13,10,0

szFlagBuf   BYTE "C:", 3 DUP (0),\
                 "P:", 3 DUP (0),\
                 "A:", 3 DUP (0),\
                 "Z:", 3 DUP (0),\
                 "S:", 3 DUP (0),\
                 "T:", 3 DUP (0),\
                 "D:", 3 DUP (0),\
                 "O:", 3 DUP (0),13,10,13,10,0