.386
.model	flat, stdcall
option	casemap :none

Include TestProc.inc
;-- helper routines
Include DlgHelper.inc
Include DlgHelper.asm
;-- show register and flags contens
Include ShowStep.inc
Include ShowStep.asm
;-- proc to examine
Include szCpy.asm

.CODE
start:
	Invoke InitCommonControls
	Invoke GetModuleHandle, NULL
	mov	hInstance,eax
	;-- allocate and initialize memory for status struct
	Invoke InitMem
	Invoke DialogBoxParam,hInstance,IDD_MAIN,0,offset DlgProc, 0
	Invoke LocalFree,pST
	Invoke ExitProcess,eax


;-- Main dialog proc
DlgProc proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

	mov	eax,uMsg
	
	.if	eax == WM_INITDIALOG
		mov edx,hWnd
		mov hCtrl,edx
		
		mov MII.cbSize, sizeof MII
		mov MII.fMask, MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE or MIIM_CHECKMARKS				
		mov MII.fType,MFT_STRING; or MFT_RADIOCHECK
		mov MII.wID,IDM_PAUSE
	;-- load icon
		Invoke LoadIcon,hInstance,200
		Invoke SendMessage,hWnd,WM_SETICON,1,eax
	;-- load and set menu
		Invoke LoadMenu,hInstance,100
		mov hMenu,eax                    ; store handle to main menu
		Invoke SetMenu,hWnd,hMenu
;		Invoke GetSubMenu, hMenu,0       ; get handle to 1st sub menu
;        mov hSMenu1,eax
        Invoke EnableMenuItem,hMenu,IDM_PAUSE,MF_GRAYED
	;-- set some controls to font bold
		Invoke CreateFontBold,hWnd,IDC_GBFLAGS
		mov hDHFont,eax
		Invoke SendDlgItemMessage,hWnd,IDC_GBFLAGS,WM_SETFONT,hDHFont,TRUE
		Invoke SendDlgItemMessage,hWnd,IDC_GBREG,WM_SETFONT,hDHFont,TRUE
	;-- disable pause button
		Invoke GetDlgItem,hWnd,IDB_STOP
		Invoke EnableWindow,eax,FALSE
		
	.elseif eax == WM_COMMAND
		LOWORD wParam
		;-- cmd message handling
		.if	eax == IDB_EXIT
			Invoke SendMessage,hWnd,WM_CLOSE,0,0
		
		.elseif eax == IDB_OPT
			Invoke DialogBoxParam,hInstance,IDD_DLGOPT,hWnd,offset DlgOptProc,0
			
		.elseif eax == IDB_TEST
		;-- create thread for procedure to test
			invoke ControlMain,hWnd,0 
			mov eax,OFFSET ThreadProc 
			Invoke CreateThread,NULL,NULL,eax,hWnd,0,ADDR ThreadID
			mov hThread,eax
			
		.elseif eax == IDB_STOP
		;-- toggles thread state
;			Invoke FlashWindow,hWnd,TRUE
			not bPFlag
			.if bPFlag == 0
				;-- continue thread executing
				Invoke ResumeThread,hThread
				
				Invoke SetWindowText,lParam,ADDR szPause
				Invoke SetWindowText,hWnd,SADD("TestProc-Running")
				Invoke LoadIcon,hInstance,202
				Invoke SendMessage,hWnd,WM_SETICON,1,eax
				mov eax,offset szPause
				mov MII.dwTypeData, eax
				Invoke SetMenuItemInfo,hMenu,IDM_PAUSE,FALSE,ADDR MII
			.elseif
				;-- stop (pause) thread executing
				Invoke SuspendThread,hThread
				
				Invoke SetWindowText,lParam,ADDR szCont
				Invoke SetWindowText,hWnd,SADD("TestProc-Paused")
				Invoke LoadIcon,hInstance,201
				Invoke SendMessage,hWnd,WM_SETICON,1,eax
				mov eax,offset szCont
				mov MII.dwTypeData,eax
				Invoke SetMenuItemInfo,hMenu,IDM_PAUSE,FALSE,ADDR MII			
			.endif
		;-- Menu message handling
		.elseif eax == IDM_EXIT
			Invoke SendMessage,hWnd,WM_CLOSE,0,0
			
		.elseif eax == IDM_START
			;-) use code from test button
			Invoke SendMessage,hWnd,WM_COMMAND,IDB_TEST,0
		
		.elseif eax == IDM_PAUSE
		;-- toggles thread state
;			Invoke FlashWindow,hWnd,TRUE
			not bPFlag
			.if bPFlag == 0
				;-- continue thread executing
				Invoke ResumeThread,hThread
				Invoke GetDlgItem,hWnd,IDB_STOP
				Invoke SetWindowText,eax,ADDR szPause
				Invoke SetWindowText,hWnd,SADD("TestProc-Running")
				Invoke LoadIcon,hInstance,202
				Invoke SendMessage,hWnd,WM_SETICON,1,eax
				mov eax,offset szPause
				mov MII.dwTypeData, eax
				Invoke SetMenuItemInfo,hMenu,IDM_PAUSE,FALSE,ADDR MII
			.elseif
				;-- stop (pause) thread executing
				Invoke SuspendThread,hThread
				Invoke GetDlgItem,hWnd,IDB_STOP
				
				Invoke SetWindowText,eax,ADDR szCont
				Invoke SetWindowText,hWnd,SADD("TestProc-Paused")
				Invoke LoadIcon,hInstance,201
				Invoke SendMessage,hWnd,WM_SETICON,1,eax
				mov eax,offset szCont
				mov MII.dwTypeData,eax
				Invoke SetMenuItemInfo,hMenu,IDM_PAUSE,FALSE,ADDR MII			
			.endif		
		.elseif eax == IDM_OPT
			Invoke DialogBoxParam,hInstance,IDD_DLGOPT,hWnd,offset DlgOptProc,0
		.endif
		
	.elseif eax == WM_FINISH
	;-- Threadproc is ready...
		invoke ControlMain,hWnd,1
		mov hThread,eax
		
	.elseif	eax == WM_CLOSE
		Invoke DestroyMenu,hMenu
		Invoke CloseHandle,hThread
		Invoke DeleteObject,hDHFont
		Invoke EndDialog,hWnd,0
	.endif

	xor	eax,eax
	ret
DlgProc endp

;-- DlgOptProc: Options dialog
DlgOptProc proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

Local szBuffer[64]:BYTE

	mov	eax,uMsg
	.if	eax == WM_INITDIALOG
	;-- save old values (for cancel)
		;-- changes are stored in STcpy and only copied to ST if user selects "Apply".
		Invoke MemCopy,pST,pSTcpy,SIZEOF (STA)
	;-- control initialisation
		Invoke ControlED,hWnd
		push ebx
		mov ebx,pSTcpy
	;-- set radiobuttons		
		mov ax,(STA PTR [ebx]).wFormatR
		.if ax == 2020h	; registers output format for file
			;-- reg output in Rows
			Invoke SendDlgItemMessage,hWnd,RB_REGROW,BM_SETCHECK,BST_CHECKED,0
		.else
			;-- reg output in columns
			Invoke SendDlgItemMessage,hWnd,RB_REGCOL,BM_SETCHECK,BST_CHECKED,0
		.endif
		mov ax,(STA PTR [ebx]).wFormatF		
		.if ax == 2020h	; flags output format for file
			;-- reg output in Rows
			Invoke SendDlgItemMessage,hWnd,RB_FLAGROW,BM_SETCHECK,BST_CHECKED,0
		.else
			;-- reg output in columns
			Invoke SendDlgItemMessage,hWnd,RB_FLAGCOL,BM_SETCHECK,BST_CHECKED,0
		.endif		
	;-- max 3 chars for proc delay
		Invoke SendDlgItemMessage,hWnd,IDC_DELAY,EM_SETLIMITTEXT,3,0
		mov ecx,(STA PTR [ebx]).dwSleep
	;-- show current delay
		Invoke dwtoa,ecx,ADDR (STA PTR [ebx]).szSleep
		Invoke SendDlgItemMessage,hWnd,IDC_DELAY,WM_SETTEXT,0,ADDR (STA PTR [ebx]).szSleep
		;-- show current path
		lea edx,(STA PTR [ebx]).szFileName
		mov ecx,[edx]
		.if ecx != 0
			Invoke SendDlgItemMessage,hWnd,IDC_PATH,WM_SETTEXT,0,edx
		.else
			Invoke SendDlgItemMessage,hWnd,IDC_PATH,WM_SETTEXT,0,ADDR szEmpty
		.endif
		
		pop ebx
		;-- set Groupbox font to bold
		Invoke SendDlgItemMessage,hWnd,IDC_GBOPT,WM_SETFONT,hDHFont,TRUE
		Invoke SendDlgItemMessage,hWnd,IDC_GBOPTREG,WM_SETFONT,hDHFont,TRUE
		Invoke SendDlgItemMessage,hWnd,IDC_GBOPTFLAG,WM_SETFONT,hDHFont,TRUE
		Invoke SendDlgItemMessage,hWnd,IDC_GBOPTOTHER,WM_SETFONT,hDHFont,TRUE
		;-- load cmd icon
		Invoke SetCmdIcon,hWnd,IDB_FILE,203
		
	.elseif eax == WM_COMMAND
		LOWORD wParam
		
		.if	eax == IDB_CANCEL
			Invoke SendMessage,hWnd,WM_CLOSE,0,0
			
		.elseif eax == IDB_APPLY
			;-- delay
			push ebx
			mov ebx,pSTcpy
			Invoke SendDlgItemMessage,hWnd,IDC_DELAY,WM_GETTEXT,4,ADDR (STA PTR [ebx]).szSleep
			Invoke atodw,ADDR (STA PTR [ebx]).szSleep
			mov (STA PTR [ebx]).dwSleep,eax
			pop ebx
			
		;-- copy changes to ST
			Invoke MemCopy,pSTcpy,pST,SIZEOF (STA)
			invoke SendMessage,hWnd,WM_CLOSE,0,0
			
		.elseif eax == IDB_FILE
			Invoke SaveDialogProc,hWnd
			
		.elseif eax == CB_FILE
			Invoke SendMessage,lParam,BM_GETCHECK,0,0
			mov edx,pSTcpy
			mov (STA PTR [edx]).dwCBState,eax
			Invoke ControlED,hWnd
		;-- format output changes
		.elseif eax == RB_REGROW
			mov edx,pSTcpy
			mov (STA PTR [edx]).wFormatR,2020h
		.elseif eax == RB_REGCOL
			mov edx,pSTcpy
			mov (STA PTR [edx]).wFormatR,0A0Dh
		.elseif eax == RB_FLAGROW
			mov edx,pSTcpy
			mov (STA PTR [edx]).wFormatF,2020h
		.elseif eax == RB_FLAGCOL
			mov edx,pSTcpy
			mov (STA PTR [edx]).wFormatF,0A0Dh
		.endif
	
	.elseif	eax == WM_CLOSE
		invoke EndDialog, hWnd, 0
	.endif
	
	xor	eax,eax
	Ret
DlgOptProc EndP

;-- ControlED: switch control status of options dialog
;              depending on file writing enabled or not
ControlED Proc hWnd:DWORD

Local hRB_REGROW:DWORD
Local hRB_REGCOL:DWORD
Local hRB_FLAGROW:DWORD
Local hRB_FLAGCOL:DWORD
Local hIDB_FILE:DWORD
Local dwState:DWORD

	Invoke GetDlgItem,hWnd,IDB_FILE
	mov hIDB_FILE,eax
	Invoke GetDlgItem,hWnd,RB_REGROW
	mov hRB_REGROW,eax
	Invoke GetDlgItem,hWnd,RB_REGCOL
	mov hRB_REGCOL,eax
	Invoke GetDlgItem,hWnd,RB_FLAGROW
	mov hRB_FLAGROW,eax
	Invoke GetDlgItem,hWnd,RB_FLAGCOL
	mov hRB_FLAGCOL,eax
	
	;-- set checkbox and button state
	mov edx,pSTcpy
	mov eax,(STA PTR [edx]).dwCBState
	.if eax == BST_UNCHECKED
		Invoke SendDlgItemMessage,hWnd,CB_FILE,BM_SETCHECK,BST_UNCHECKED,0
		mov dwState,FALSE
	.elseif
		Invoke SendDlgItemMessage,hWnd,CB_FILE,BM_SETCHECK,BST_CHECKED,0
		mov dwState,TRUE
	.endif
	
	Invoke EnableWindow,hRB_FLAGCOL,dwState
	Invoke EnableWindow,hRB_FLAGROW,dwState
	Invoke EnableWindow,hRB_REGCOL,dwState		
	Invoke EnableWindow,hRB_REGROW,dwState		
	Invoke EnableWindow,hIDB_FILE,dwState		
	
	Ret
ControlED EndP

;-- ThreadProc: Start procedure to test in own thread
ThreadProc PROC USES ecx hWnd:DWORD

	;-- Procedure to test
	Invoke SzCpy_dw1,ADDR String1,ADDR String2
	;-- testing finished
    Invoke PostMessage,hWnd,WM_FINISH,NULL,NULL
    ret 
ThreadProc ENDP 

;-- ControlMain: switch control status of main dialog
;                depending on run or paused state
ControlMain  PROC hWnd:DWORD,dwSwitch:DWORD

local hCtEXIT:HANDLE
local hCtTEST:HANDLE
local hCtSTOP:HANDLE
local hCtOPT:HANDLE

	Invoke GetDlgItem,hWnd,IDB_EXIT
	mov hCtEXIT,eax
	Invoke GetDlgItem,hWnd,IDB_TEST
	mov hCtTEST,eax
	Invoke GetDlgItem,hWnd,IDB_STOP
	mov hCtSTOP,eax
	Invoke GetDlgItem,hWnd,IDB_OPT
	mov hCtOPT,eax
	
	.if dwSwitch == 0 ; TestProc start
		Invoke SetWindowText,hWnd,SADD("TestProc-Running")
		Invoke LoadIcon,hInstance,202
	.else
		Invoke SetWindowText,hWnd,SADD("TestProc-Ready")
		Invoke LoadIcon,hInstance,200
	.endif
	Invoke SendMessage,hWnd,WM_SETICON,1,eax	

	Invoke EnableWindow,hCtEXIT,dwSwitch
	Invoke EnableWindow,hCtTEST,dwSwitch
	Invoke EnableWindow,hCtOPT,dwSwitch
	Invoke EnableMenuItem,hMenu,IDM_PAUSE,dwSwitch
	xor dwSwitch,1		
	Invoke EnableMenuItem,hMenu,IDM_START,dwSwitch
	Invoke EnableWindow,hCtSTOP,dwSwitch
	Invoke EnableMenuItem,hMenu,IDM_OPT,dwSwitch
	Invoke DrawMenuBar,hWnd
	
	xor eax,eax
	Ret
ControlMain EndP

;-- InitMem: Allocate memory for STATUS struct
;-- and initialize structure with standard settings 
InitMem Proc USES EBX EDI

Local pFilePart:DWORD
Local szFile:DWORD

	mov eax,SIZEOF(STA)
	shl eax,1			; alloc mem for to structures
	Invoke LocalAlloc,LPTR,eax
	mov pST,eax			; structure for settings
	add eax,SIZEOF(STA)
	mov pSTcpy,eax		; structure for options dialog
	
	mov ebx,pST
	ASSUME EBX:PTR STA
	
	mov [ebx].dwSleep,100		; default: 100ms delay
	mov [ebx].dwCBState,BST_UNCHECKED	; default: no logfile writing
	mov WORD PTR [ebx].wFormatR,0A0Dh	; = Columns
	mov WORD PTR [ebx].wFormatF,2020h	; = Rows
	lea edx,szFile
	mov eax,2A2E2Ah
	mov [edx],eax
	lea edx,[ebx].szFileName
	Invoke GetFullPathName,ADDR szFile,MAX_PATH,edx,ADDR pFilePart
	.If eax != 0
		mov edx,pFilePart
	.Else
    	lea edx,[ebx].szFileName
    .Endif
	mov eax,2E676F4Ch
	mov ecx,747874h
	mov [edx],eax
	mov [edx+4],ecx

	ASSUME EBX:NOTHING
	xor eax,eax
	Ret
	
InitMem EndP

end start